# Contributing to DocumentDB

Thank you for your interest in contributing to DocumentDB. There are several ways through which contributions to the project can be made and you can get involved.

## Asking Questions

[Join us on Discord](https://discord.gg/WXUrVbnt4n) to engage directly with our team and the community with any questions you may have. Our channel inside the Microsoft OSS server is not only a place for immediate assistance but also a hub for discussing project updates, upcoming features, and technical challenges. We host regular meetings where team members and contributors can interact directly to ask questions, share feedback, and discuss their ideas in real time.

## Reporting Issues

Before a new issue is created for a bug or feature request, please check the list of open issues to avoid multiple issues being created for the same bug or feature. If one already exists, add a reaction and relevant comments for additional clarity if needed.

## How to Contribute

We encourage community members to participate by reporting issues, suggesting new features, or contributing code.

### 1. General Contributions

The more descriptive the issue is and the more information that can be provided, the more helpful it will be to the community and the contributors to pick up the issue.

For each issue created, please include: 

- A brief description of the suggestion or issue.

- Relevant details such as the operating system you were using, if applicable.

- Clear, step-by-step instructions or context that describe how the issue occurred or how the feature would function.
  
- The expected outcome versus the actual result or behavior observed, if relevant.

### Code Contributions

For those looking to contribute code, whether for bug fixes or new features, please ensure your issues and pull requests include the following:

- A code snippet that reliably reproduces the issue or demonstrates the new feature.

- An accessible repository link that can be cloned, built, and run, providing a complete environment for testing and verifying the issue or feature.

- Clear documentation or comments in the code explaining the changes made and their purpose.

## Pull Requests

Before a pull request is accepted, you will need to sign a [Contributor License Agreement (CLA)](https://cla.opensource.microsoft.com/), an automated process that is triggered by a bot and only needed once. If you have previously signed the CLA, the status check turns green instantly. If you are yet to sign the CLA, a comment is added with more information and instructions on how to sign the CLA.

For the smoothest and fastest turnaround time, we request that a single pull request be created along with a link to a previously created issue describing the bug or feature request.

Wherever applicable, pull requests should contain tests.

## Suggestions

We’re keen to hear your feedback on the future of DocumentDB. Feature Requests can be submitted through the issue tracker. To ensure suggestions are reviewed faster, we do request that the following information be provided for each suggestion:

- Purpose/Motivation for the feature

- Description of the problem space that will be solved or addressed by this feature

- Description of a few scenarios that will help test and validate this feature

For even quicker engagement and real-time discussions about your feature ideas, join our [Discord channel](https://discord.gg/WXUrVbnt4n). Our team and community members are actively available to provide feedback, answer questions, and collaborate on refining your suggestions before they are formally submitted through the issue tracker.

## Discussion Etiquette

To provide all members of the community with a safe space for contributions and discussions, we request that comments always be courteous and respectful of others.
